/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.FacadeCosmos;

import com.cosmodas.EntCosmos.*;

import java.util.ArrayList;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 * @author obper
 */
@Stateless
public class PedidosFacade extends AbstractFacade<Pedidos> implements PedidosFacadeLocal {

    @PersistenceContext(unitName = "wcosmodasPersistent")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public PedidosFacade() {
        super(Pedidos.class);
    }

    @Override
    public Consultores findConsultor(String consultorCodigo) {
        Query q = em.createNamedQuery("Consultores.findByConsultorCodigo");
        q.setParameter("consultorCodigo", consultorCodigo);
        Consultores rs = (Consultores) q.getSingleResult();
        return rs;
    }

    @Override
    public Consultores buscarConsultor(String consultorCodigo) {
        Query q = em.createNamedQuery("Consultores.findByConsultorCodigo");
        q.setParameter("consultorCodigo", consultorCodigo);
        Consultores rs = (Consultores) q.getSingleResult();
        return rs;
    }

    @Override
    public String obtenerPedidoSig(String territorio) {
        StringBuilder sql = new StringBuilder("SELECT ultimo_pedido(?)");
        Query q = em.createNativeQuery(sql.toString());
        q.setParameter(1, territorio);
        List<String> result = q.getResultList();

        String rs = result.get(0);
        return rs;
    }

    @Override
    public void borraDetallePedido(PedidosPK pk) {

        StringBuilder sql = new StringBuilder("delete from detalle_pedidos where numero_pedido = ? and territorio =?");
        Query q = em.createNativeQuery(sql.toString());
        q.setParameter(1, pk.getNumeroPedido());
        q.setParameter(2, pk.getTerritorio());
        q.executeUpdate();

    }

    @Override
    public Pedidos obtenerPedido(String codigoPedido) {

        Pedidos rs = new Pedidos();
        List<Pedidos> rsl = new ArrayList<>();
        StringBuilder sql = new StringBuilder("select * from pedidos where concat(territorio,numero_pedido) = ?");
        Query q = em.createNativeQuery(sql.toString(), Pedidos.class);
        q.setParameter(1, codigoPedido);
        rsl.addAll(q.getResultList());


        rs = rsl.get(0);

        return rs;

    }

    @Override
    public List<DetallePedidos> obtenerPedidoDetalle(String codigoPedido) {

        List<DetallePedidos> rsl = new ArrayList<>();
        StringBuilder sql = new StringBuilder("select * from detalle_pedidos where concat(territorio,numero_pedido) = ?");
        Query q = em.createNativeQuery(sql.toString(), DetallePedidos.class);
        q.setParameter(1, codigoPedido);
        rsl.addAll(q.getResultList());
        return rsl;

    }

}
